package src;

import java.util.ArrayList;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.902535BD-DCDB-74B8-544D-F0A805FBF787]
// </editor-fold> 
public class Territorio {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.9007FE48-7FA2-B88E-E6F3-7F2FC96D7447]
    // </editor-fold> 
    private ArrayList<Territorio> territoriosAdy;//contendra los territorios que podemos atacar

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.24656637-7789-142E-24F6-317170E00B98]
    // </editor-fold> 
    private String nombreTerritorio;//nombre del territorio

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B23D2D36-8541-95B0-35D7-904CEE7F0003]
    // </editor-fold> 
    private int numEjercito;//numero de ejercitos que hay en el territorio

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6E3C1909-8EE9-6783-C860-FDA5F15FDEFF]
    // </editor-fold> 
    private Jugador propietarioTer;//jugador que posee el territorio

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D91B3567-26FC-8729-308D-E518F5BFF9BA]
    // </editor-fold> 
    public Territorio (String nombre) {
        setNombreTerritorio(nombre);
        setNumEjercito(0);
    }
    
    //constructor en el que creamos todos los territorios y los adyacentes de estos
    public Territorio (ArrayList<Territorio> ter, ArrayList<Continente> conti) {
        //creamos los ter
        ter.add(0,new Territorio("Alaska"));
        ter.add(1,new Territorio("Alberta"));
        ter.add(2,new Territorio("América Central"));
        ter.add(3,new Territorio("Estados Unidos del Este"));
        ter.add(4,new Territorio("Groenlandia"));
        ter.add(5,new Territorio("Territorio del Noroeste"));
        ter.add(6,new Territorio("Ontario"));
        ter.add(7,new Territorio("Quebec"));
        ter.add(8,new Territorio("Estados Unidos del Oeste"));
        //añadimos los ter creados a sus respectivo continentes
        ArrayList<Territorio> cont1 = new ArrayList(9);
        cont1.add(ter.get(0));
        cont1.add(ter.get(1));
        cont1.add(ter.get(2));
        cont1.add(ter.get(3));
        cont1.add(ter.get(4));
        cont1.add(ter.get(5));
        cont1.add(ter.get(6));
        cont1.add(ter.get(7));
        cont1.add(ter.get(8));
        conti.get(0).setTerritorio(cont1);
        
        
        ter.add(9,new Territorio("Argentina"));
        ter.add(10,new Territorio("Brasil"));
        ter.add(11,new Territorio("Perú"));
        ter.add(12,new Territorio("Venezuela"));
        ArrayList<Territorio> cont2 = new ArrayList(4);
        cont2.add(ter.get(9));
        cont2.add(ter.get(10));
        cont2.add(ter.get(11));
        cont2.add(ter.get(12));
        conti.get(1).setTerritorio(cont2);
        
        ter.add(13,new Territorio("Gran Bretaña"));
        ter.add(14,new Territorio("Iceland"));
        ter.add(15,new Territorio("Europa del Norte"));
        ter.add(16,new Territorio("Escandinavia"));
        ter.add(17,new Territorio("Europa del Sur"));
        ter.add(18,new Territorio("Ucrania"));
        ter.add(19,new Territorio("Europa Occidental"));
        ArrayList<Territorio> cont3 = new ArrayList(7);
        cont3.add(ter.get(13));
        cont3.add(ter.get(14));
        cont3.add(ter.get(15));
        cont3.add(ter.get(16));
        cont3.add(ter.get(17));
        cont3.add(ter.get(18));
        cont3.add(ter.get(19));
        conti.get(2).setTerritorio(cont3);
        
        ter.add(20,new Territorio("Congo"));
        ter.add(21,new Territorio("África Oriental"));
        ter.add(22,new Territorio("Egipto"));
        ter.add(23,new Territorio("Madagascar"));
        ter.add(24,new Territorio("África del Norte"));
        ter.add(25,new Territorio("Sudáfrica"));
        ArrayList<Territorio> cont4 = new ArrayList(6);
        cont4.add(ter.get(20));
        cont4.add(ter.get(21));
        cont4.add(ter.get(22));
        cont4.add(ter.get(23));
        cont4.add(ter.get(24));
        cont4.add(ter.get(25));
        conti.get(3).setTerritorio(cont4);
        
        ter.add(26,new Territorio("Afghanistan"));
        ter.add(27,new Territorio("China"));
        ter.add(28,new Territorio("India"));
        ter.add(29,new Territorio("Irkutsk"));
        ter.add(30,new Territorio("Japón"));
        ter.add(31,new Territorio("Kamchatka"));
        ter.add(32,new Territorio("Oriente Medio"));
        ter.add(33,new Territorio("Mongolia"));
        ter.add(34,new Territorio("Siam"));
        ter.add(35,new Territorio("Siberia"));
        ter.add(36,new Territorio("Ural"));
        ter.add(37,new Territorio("Yakutsk"));
        ArrayList<Territorio> cont5 = new ArrayList(12);
        cont5.add(ter.get(26));
        cont5.add(ter.get(27));
        cont5.add(ter.get(28));
        cont5.add(ter.get(29));
        cont5.add(ter.get(30));
        cont5.add(ter.get(31));
        cont5.add(ter.get(32));
        cont5.add(ter.get(33));
        cont5.add(ter.get(34));
        cont5.add(ter.get(35));
        cont5.add(ter.get(36));
        cont5.add(ter.get(37));
        conti.get(4).setTerritorio(cont5);
        
        ter.add(38,new Territorio("Autralia Oriental"));
        ter.add(39,new Territorio("Indonesia"));
        ter.add(40,new Territorio("Nueva Guinea"));
        ter.add(41,new Territorio("Australia Occidental"));
        ArrayList<Territorio> cont6 = new ArrayList(12);
        cont6.add(ter.get(38));
        cont6.add(ter.get(39));
        cont6.add(ter.get(40));
        cont6.add(ter.get(41));
        conti.get(5).setTerritorio(cont6);
        
        //creamos los adyacentes de cada territorio
        ArrayList<Territorio> ady = new ArrayList<Territorio>(3);
        ady.add(ter.get(1));
        ady.add(ter.get(5));
        ady.add(ter.get(31));
        //Territorio t = ter.get(0);
        ter.get(0).setTerritoriosAdy(ady);

        ArrayList<Territorio> ady2 = new ArrayList<Territorio>(4);
        ady2.add(ter.get(5));
        ady2.add(ter.get(6));
        ady2.add(ter.get(3));
        ady2.add(ter.get(8));
        //Territorio t2 = ter.get(1);
        ter.get(1).setTerritoriosAdy(ady2);
        
        ArrayList<Territorio> ady3 = new ArrayList<Territorio>(4);
        ady3.add(ter.get(4));
        ady3.add(ter.get(6));
        ady3.add(ter.get(1));
        ady3.add(ter.get(0));
        Territorio t3 = ter.get(5);
        t3.setTerritoriosAdy(ady3);
        
        ArrayList<Territorio> ady4 = new ArrayList<Territorio>(6);
        ady4.add(ter.get(5));
        ady4.add(ter.get(1));
        ady4.add(ter.get(3));
        ady4.add(ter.get(7));
        ady4.add(ter.get(4));
        ady4.add(ter.get(8));
        Territorio t4 = ter.get(6);
        t4.setTerritoriosAdy(ady4);
        
        ArrayList<Territorio> ady5 = new ArrayList<Territorio>(3);
        ady5.add(ter.get(6));
        ady5.add(ter.get(3));
        ady5.add(ter.get(4));
        Territorio t5 = ter.get(7);
        t5.setTerritoriosAdy(ady5);
        
        ArrayList<Territorio> ady6 = new ArrayList<Territorio>(4);
        ady6.add(ter.get(1));
        ady6.add(ter.get(6));
        ady6.add(ter.get(3));
        ady6.add(ter.get(2));
        Territorio t6 = ter.get(8);
        t6.setTerritoriosAdy(ady6);
        
        ArrayList<Territorio> ady7 = new ArrayList<Territorio>(5);
        ady7.add(ter.get(2));
        ady7.add(ter.get(8));
        ady7.add(ter.get(1));
        ady7.add(ter.get(6));
        ady7.add(ter.get(7));
        Territorio t7 = ter.get(3);
        t7.setTerritoriosAdy(ady7);
        
        ArrayList<Territorio> ady8 = new ArrayList<Territorio>(3);
        ady8.add(ter.get(3));
        ady8.add(ter.get(8));
        ady8.add(ter.get(12));
        Territorio t8 = ter.get(2);
        t8.setTerritoriosAdy(ady8);
        
        ArrayList<Territorio> ady9 = new ArrayList<Territorio>(4);
        ady9.add(ter.get(5));
        ady9.add(ter.get(6));
        ady9.add(ter.get(7));
        ady9.add(ter.get(14));
        Territorio t9 = ter.get(4);
        t9.setTerritoriosAdy(ady9);
        
        ArrayList<Territorio> ady10 = new ArrayList<Territorio>(2);
        ady10.add(ter.get(10));
        ady10.add(ter.get(11));
        Territorio t10 = ter.get(9);
        t10.setTerritoriosAdy(ady10);
        
        ArrayList<Territorio> ady11 = new ArrayList<Territorio>(4);
        ady11.add(ter.get(9));
        ady11.add(ter.get(11));
        ady11.add(ter.get(12));
        ady11.add(ter.get(24));
        Territorio t11 = ter.get(10);
        t11.setTerritoriosAdy(ady11);
        
        ArrayList<Territorio> ady12 = new ArrayList<Territorio>(3);
        ady12.add(ter.get(9));
        ady12.add(ter.get(10));
        ady12.add(ter.get(12));
        Territorio t12 = ter.get(11);
        t12.setTerritoriosAdy(ady12);
        
        ArrayList<Territorio> ady13 = new ArrayList<Territorio>(3);
        ady13.add(ter.get(2));
        ady13.add(ter.get(10));
        ady13.add(ter.get(11));
        Territorio t13 = ter.get(12);
        t13.setTerritoriosAdy(ady13);
        
        ArrayList<Territorio> ady14 = new ArrayList<Territorio>(4);
        ady14.add(ter.get(14));
        ady14.add(ter.get(15));
        ady14.add(ter.get(16));
        ady14.add(ter.get(19));
        Territorio t14 = ter.get(13);
        t14.setTerritoriosAdy(ady14);
        
        ArrayList<Territorio> ady15 = new ArrayList<Territorio>(3);
        ady15.add(ter.get(13));
        ady15.add(ter.get(16));
        ady15.add(ter.get(4));
        Territorio t15 = ter.get(14);
        t15.setTerritoriosAdy(ady15);
        
        ArrayList<Territorio> ady16 = new ArrayList<Territorio>(5);
        ady16.add(ter.get(13));
        ady16.add(ter.get(16));
        ady16.add(ter.get(17));
        ady16.add(ter.get(18));
        ady16.add(ter.get(19));
        Territorio t16 = ter.get(15);
        t16.setTerritoriosAdy(ady16);
        
        ArrayList<Territorio> ady17 = new ArrayList<Territorio>(4);
        ady17.add(ter.get(13));
        ady17.add(ter.get(15));
        ady17.add(ter.get(14));
        ady17.add(ter.get(18));
        Territorio t17 = ter.get(16);
        t17.setTerritoriosAdy(ady17);
        
        ArrayList<Territorio> ady18 = new ArrayList<Territorio>(5);
        ady18.add(ter.get(18));
        ady18.add(ter.get(15));
        ady18.add(ter.get(19));
        ady18.add(ter.get(22));
        ady18.add(ter.get(24));//posiblemente me falte uno mas, lo tengo que comprobar es el 32
        Territorio t18 = ter.get(17);
        t18.setTerritoriosAdy(ady18);
        
        ArrayList<Territorio> ady19 = new ArrayList<Territorio>(6);
        ady19.add(ter.get(17));
        ady19.add(ter.get(16));
        ady19.add(ter.get(15));
        ady19.add(ter.get(26));
        ady19.add(ter.get(32));
        ady19.add(ter.get(36));
        Territorio t19 = ter.get(18);
        t19.setTerritoriosAdy(ady19);
        
        ArrayList<Territorio> ady20 = new ArrayList<Territorio>(4);
        ady20.add(ter.get(13));
        ady20.add(ter.get(15));
        ady20.add(ter.get(17));
        ady20.add(ter.get(24));
        Territorio t20 = ter.get(19);
        t20.setTerritoriosAdy(ady20);
        //africa
        ArrayList<Territorio> ady21 = new ArrayList<Territorio>(3);
        ady21.add(ter.get(21));
        ady21.add(ter.get(24));
        ady21.add(ter.get(25));
        Territorio t21 = ter.get(20);
        t21.setTerritoriosAdy(ady21);
        
        ArrayList<Territorio> ady22 = new ArrayList<Territorio>(5);
        ady22.add(ter.get(20));
        ady22.add(ter.get(22));
        ady22.add(ter.get(23));
        ady22.add(ter.get(24));
        ady22.add(ter.get(25));
        Territorio t22 = ter.get(21);
        t22.setTerritoriosAdy(ady22);
        
        ArrayList<Territorio> ady23 = new ArrayList<Territorio>(4);
        ady23.add(ter.get(21));
        ady23.add(ter.get(24));
        ady23.add(ter.get(17));
        ady23.add(ter.get(32));
        Territorio t23 = ter.get(22);
        t23.setTerritoriosAdy(ady23);
        
        ArrayList<Territorio> ady24 = new ArrayList<Territorio>(2);
        ady24.add(ter.get(21));
        ady24.add(ter.get(25));
        Territorio t24 = ter.get(23);
        t24.setTerritoriosAdy(ady24);
        
        ArrayList<Territorio> ady25 = new ArrayList<Territorio>(6);
        ady25.add(ter.get(20));
        ady25.add(ter.get(21));
        ady25.add(ter.get(22));
        ady25.add(ter.get(19));
        ady25.add(ter.get(17));
        ady25.add(ter.get(10));
        Territorio t25 = ter.get(24);
        t25.setTerritoriosAdy(ady25);
        
        ArrayList<Territorio> ady26 = new ArrayList<Territorio>(3);
        ady26.add(ter.get(20));
        ady26.add(ter.get(21));
        ady26.add(ter.get(23));
        Territorio t26 = ter.get(25);
        t26.setTerritoriosAdy(ady26);
        //asia
        ArrayList<Territorio> ady27 = new ArrayList<Territorio>(5);
        ady27.add(ter.get(18));
        ady27.add(ter.get(27));
        ady27.add(ter.get(28));
        ady27.add(ter.get(32));
        ady27.add(ter.get(36));
        Territorio t27 = ter.get(26);
        t27.setTerritoriosAdy(ady27);
        
        ArrayList<Territorio> ady28 = new ArrayList<Territorio>(6);
        ady28.add(ter.get(26));
        ady28.add(ter.get(28));
        ady28.add(ter.get(33));
        ady28.add(ter.get(34));
        ady28.add(ter.get(35));
        ady28.add(ter.get(36));
        Territorio t28 = ter.get(27);
        t28.setTerritoriosAdy(ady28);
        
        ArrayList<Territorio> ady29 = new ArrayList<Territorio>(4);
        ady29.add(ter.get(26));
        ady29.add(ter.get(27));
        ady29.add(ter.get(32));
        ady29.add(ter.get(34));
        Territorio t29 = ter.get(28);
        t29.setTerritoriosAdy(ady29);
        
        ArrayList<Territorio> ady30 = new ArrayList<Territorio>(4);
        ady30.add(ter.get(31));
        ady30.add(ter.get(33));
        ady30.add(ter.get(35));
        ady30.add(ter.get(37));
        Territorio t30 = ter.get(29);
        t30.setTerritoriosAdy(ady30);
        
        ArrayList<Territorio> ady31 = new ArrayList<Territorio>(2);
        ady31.add(ter.get(31));
        ady31.add(ter.get(33));
        Territorio t31 = ter.get(30);
        t31.setTerritoriosAdy(ady31);
        
        ArrayList<Territorio> ady32 = new ArrayList<Territorio>(5);
        ady32.add(ter.get(0));
        ady32.add(ter.get(30));
        ady32.add(ter.get(29));
        ady32.add(ter.get(33));
        ady32.add(ter.get(37));
        Territorio t32 = ter.get(31);
        t32.setTerritoriosAdy(ady32);
        
        ArrayList<Territorio> ady33 = new ArrayList<Territorio>(4);//posiblemente falte uno
        ady33.add(ter.get(26));
        ady33.add(ter.get(28));
        ady33.add(ter.get(22));
        ady33.add(ter.get(18));
        Territorio t33 = ter.get(32);
        t33.setTerritoriosAdy(ady33);
        
        ArrayList<Territorio> ady34 = new ArrayList<Territorio>(5);
        ady34.add(ter.get(31));
        ady34.add(ter.get(30));
        ady34.add(ter.get(29));
        ady34.add(ter.get(27));
        ady34.add(ter.get(35));
        Territorio t34 = ter.get(33);
        t34.setTerritoriosAdy(ady34);
        
        ArrayList<Territorio> ady35 = new ArrayList<Territorio>(3);
        ady35.add(ter.get(28));
        ady35.add(ter.get(27));
        ady35.add(ter.get(39));
        Territorio t35 = ter.get(34);
        t35.setTerritoriosAdy(ady35);
        
        ArrayList<Territorio> ady36 = new ArrayList<Territorio>(5);
        ady36.add(ter.get(36));
        ady36.add(ter.get(37));
        ady36.add(ter.get(33));
        ady36.add(ter.get(27));
        ady36.add(ter.get(29));
        Territorio t36 = ter.get(35);
        t36.setTerritoriosAdy(ady36);
        
        ArrayList<Territorio> ady37 = new ArrayList<Territorio>(4);
        ady37.add(ter.get(35));
        ady37.add(ter.get(27));
        ady37.add(ter.get(26));
        ady37.add(ter.get(18));
        Territorio t37 = ter.get(36);
        t37.setTerritoriosAdy(ady37);
        
        ArrayList<Territorio> ady38 = new ArrayList<Territorio>(3);
        ady38.add(ter.get(35));
        ady38.add(ter.get(31));
        ady38.add(ter.get(29));
        Territorio t38 = ter.get(37);
        t38.setTerritoriosAdy(ady38);
        //australia
        ArrayList<Territorio> ady39 = new ArrayList<Territorio>(2);
        ady39.add(ter.get(40));
        ady39.add(ter.get(41));
        Territorio t39 = ter.get(38);
        t39.setTerritoriosAdy(ady39);
        
        ArrayList<Territorio> ady40 = new ArrayList<Territorio>(3);
        ady40.add(ter.get(40));
        ady40.add(ter.get(41));
        ady40.add(ter.get(34));
        Territorio t40 = ter.get(39);
        t40.setTerritoriosAdy(ady40);
        
        ArrayList<Territorio> ady41 = new ArrayList<Territorio>(3);
        ady41.add(ter.get(39));
        ady41.add(ter.get(41));
        ady41.add(ter.get(38));
        Territorio t41 = ter.get(40);
        t41.setTerritoriosAdy(ady41);
        
        ArrayList<Territorio> ady42 = new ArrayList<Territorio>(3);
        ady42.add(ter.get(39));
        ady42.add(ter.get(40));
        ady42.add(ter.get(38));
        Territorio t42 = ter.get(41);
        t42.setTerritoriosAdy(ady42);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.AA72938F-A3F7-0C82-D9D4-3CA443F1E6B2]
    // </editor-fold> 
    public String getNombreTerritorio () {
        return nombreTerritorio;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E810AB2E-44FA-EC17-9AAC-1422730E934C]
    // </editor-fold> 
    public void setNombreTerritorio (String val) {
        nombreTerritorio = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FBCC0E41-A9CB-8BB2-6E52-1350282180D8]
    // </editor-fold> 
    public int getNumEjercito () {
        return numEjercito;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C5921497-5B82-0AD6-0407-1C9BF5346E0E]
    // </editor-fold> 
    public void setNumEjercito (int val) {
        numEjercito = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6FEBE10D-CEA3-86FA-44D4-2E7055808F8F]
    // </editor-fold> 
    public Jugador getPropietarioTer () {
        return propietarioTer;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D9E74123-143E-5A62-52D2-20A9CEDB64D4]
    // </editor-fold> 
    public void setPropietarioTer (Jugador val) {
        propietarioTer = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D054F0C1-4654-39D4-7A09-BA27C4D0E6A5]
    // </editor-fold> 
    public ArrayList<Territorio> getTerritoriosAdy () {
        return territoriosAdy;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.70A27C5A-A2B3-D3BF-213B-F1842C540780]
    // </editor-fold> 
    public void setTerritoriosAdy (ArrayList<Territorio> val) {
        territoriosAdy = val;
    }
   
}

