package src;

import java.util.Random;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.96229B1B-58FA-6BBB-F3EC-CEAB34786EF6]
// </editor-fold> 
public class Dado {
    private int valor; //valor del dado 1 a 6
    private char tipo; //tipo de dado a utilizar a:atacar; d:defender
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D932C467-2145-0291-C84D-822FC5FA850A]
    // </editor-fold> 
    
    //el constructor pide el tipo de dado, y lo crea dandole un valor random
    public Dado (char t) {
        Random rnd = new Random();
        valor = rnd.nextInt(6)+1;
        tipo = t;
    }

    public void setValor(int v){
        valor = v;
    }
    
    public int getValor(){
        return valor;
    }
    
    public void setTipo(char t){
        tipo = t;
    }
    
    public char getTipo(){
        return tipo;
    }
    
    //compara el dado con otro y devuleve true si es mejor dependiendo del tipo
    public boolean compararDado(Dado d){
        boolean mejor = false;
        if (tipo == 'd' && valor >= d.getValor()) mejor = true; 
        if(tipo == 'a' && valor > d.getValor()) mejor = true;
        return mejor;
    }
    
    @Override //le dice a java que el metodo ha sido sobreescrito en esta clase
    //sobreescribimos el metodo toString() para que salga lo deseado
    public String toString() {
        if (tipo == 'd') 
            return "Dado de defensa, valor: "+valor;
	else
            return "Dado de ataque, valor: "+valor;
    }
}